

//  ******     two positions Servo controlor   ******
//                     PIC12f675
//  fast version, servo turn side to side as soon as possible
//  botten A/B to select position A/B ,under prog model to +/- PWM 
//  botton prog to switch between programming/run model
//  LED A/B light to indicate A/B position, flashing when programming
//
//  *****  ilufa@yahoo.com   philip sun / Taiwan ***** 



#include <12F675.h>
#device adc=8

#FUSES NOWDT                    //No Watch Dog Timer
#FUSES INTRC_IO                 //Internal RC Osc, no CLKOUT
#FUSES NOCPD                    //No EE protection
#FUSES NOPROTECT                //Code not protected from reading
#FUSES noMCLR                   //Master Clear pin used for I/O
#FUSES PUT                      //No Power Up Timer
#FUSES BROWNOUT                 //Reset when brownout detected

#use delay(clock=4000000)

#define button_A      PIN_A0
#define button_B      PIN_A1
#define LED_A         PIN_A5
#define LED_B         PIN_A4
#define PWM_out       PIN_A2
#define button_prog   PIN_A3

int i,x;
int PWM_data_A = 100;
int PWM_data_B = 200;
int PWM_data =100 ;
int prog_status=0;           // 1= prog, 0=run
int position_status=0;       // 0=A, 1=B

int PWM_data_max =210;
int PWM_data_min =90;
int flashing_count=0;


#int_RTCC
RTCC_isr() {
if (x>62) {                         // (256uS+ N)*78=25mS, 62=20mS
   x=0;
   output_high (PWM_out);
   for (i=1; i <= PWM_data; ++i)    
      delay_us(2);                  // delay 2 us make 10uS cyclo
      output_low (PWM_out);
   }
   
else (++x);
   enable_interrupts(INT_RTCC);
   enable_interrupts(GLOBAL);  
   //  return(0);   return may cause trouble 
}

void flashing_LED(){
 if(prog_status==1) {   // 1= prog, 0=run
   flashing_count++;
   
    if (flashing_count>=10){                      // flashing rate  
         flashing_count=0;                      
      if (position_status==1){ // 0=A, 1=B
         output_low(LED_B);    // B light, A dark
         output_high(LED_A);
      }
      if (position_status==0){
         output_low(LED_A);   // A light, B dark
         output_high(LED_B);
         }
      }
    if (flashing_count>5){                        // turn LED all OFF
       output_high(LED_B);
       output_high(LED_A);
       } 
       delay_mS(20); 
      
}  
}

void read_data(){
//   disable_interrupts(INT_RTCC);
//   disable_interrupts(GLOBAL);
   PWM_data_A = read_EEPROM(10);
   PWM_data_B = read_EEPROM(11);
   position_status = read_EEPROM(12);
//   enable_interrupts(INT_RTCC);
//  enable_interrupts(GLOBAL);

}

Void write_data(){         // write data cost mS+, but need not  to stop INT 
//   disable_interrupts(INT_RTCC);
//  disable_interrupts(GLOBAL);
  delay_uS(100);
   write_EEPROM(10,PWM_data_A );
 delay_uS(100);
   write_EEPROM(11,PWM_data_B ); 
 delay_uS(100);
   write_EEPROM(12,position_status );
 delay_uS(100);
//   enable_interrupts(INT_RTCC);
//   enable_interrupts(GLOBAL);
}

void test_button_A()
{ 
while (!input(button_A)){
     delay_mS(20);       
   if (!input(button_A))  {
   
     if(prog_status==0) {   // 1=prog 0=run
     position_status=0;       // position_status 0=A, 1=B
     write_data();
     PWM_data =PWM_data_A;
     output_high(LED_B);
     output_low(LED_A);
     }    
     else {                    // 1=prog 
         if(position_status==0){    // position_status 0=A, 1=B
         PWM_data_A++;
         if (PWM_data_A>PWM_data_max) PWM_data_A=PWM_data_max;
         PWM_data =PWM_data_A;
         }
         if(position_status==1){
         PWM_data_B++;
         if (PWM_data_B>PWM_data_max) PWM_data_B=PWM_data_max;
         PWM_data =PWM_data_B;
         }
         
     delay_mS(40);      // control key-in repeat rate
    flashing_LED();
     }
}
}
}





void test_button_B()
{ 
while (!input(button_B)){
     delay_mS(20);    
   if (!input(button_B))  {
   
    if(prog_status==0) {   // 1=prog 0=run
     position_status=1;       //position_status 0=A, 1=B
     write_data();
     PWM_data =PWM_data_B;
     output_high(LED_A);
     output_low(LED_B);
     }     
        else {                    // run main
         if(position_status==0){    // position_status 0=A, 1=B
         PWM_data_A--;
            if (PWM_data_A<PWM_data_min) PWM_data_A=PWM_data_min;
         PWM_data =PWM_data_A;
         }
         if(position_status==1){
         PWM_data_B--;
            if (PWM_data_B<PWM_data_min) PWM_data_B=PWM_data_min;
         PWM_data =PWM_data_B;
         }
     delay_mS(40);      // control key-in repeat rate
    flashing_LED();
}
}
}
}



void test_button_prog()
{
if (!input(button_prog)){
   delay_mS(20);  
   
  if (!input(button_prog))  {
  while (!input(button_prog)){}   // wait for botton released
   if(prog_status==0) {       // 1= prog, 0=run
      prog_status=1;
      flashing_LED();         // fast respone to button psh
       }
    else    {                   //prog_status==1 prog
    prog_status=0;  
    if (position_status){ // 0=A, 1=B
         output_low(LED_B);    // B light, A dark
         output_high(LED_A);
    }
      else{
         output_low(LED_A);   // A light, B dark
         output_high(LED_B);    
      }   
      
      
  write_data();          // quit form programming
      

      }
      
     delay_mS(100);      // long delay to prevent key-in repeat 
}
}
}



void main()
{

   port_a_pullups(TRUE);                  // pull-up I/O ********
   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_OFF);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);  // int per 256 uS
   setup_timer_1(T1_DISABLED);
   setup_comparator(NC_NC);
   setup_vref(FALSE); 

   
  read_data();
  if (PWM_data_A>PWM_data_max)PWM_data_A=PWM_data_max;
  if (PWM_data_A<PWM_data_min)PWM_data_A=PWM_data_min;
  if (PWM_data_B>PWM_data_max)PWM_data_B=PWM_data_max;
  if (PWM_data_B<PWM_data_min)PWM_data_B=PWM_data_min;
  if (position_status>1) position_status=1;
  write_data();
  prog_status=0;           // 1=prog 0=run
   if (position_status==1){
     PWM_data =PWM_data_B;
     output_high(LED_A);
     output_low(LED_B);
     }
     else{                    // position_status 0=A, 1=B
     PWM_data =PWM_data_A;
     output_high(LED_B);
     output_low(LED_A);
   }
   
    enable_interrupts(INT_RTCC);
    enable_interrupts(GLOBAL);
  

 while(true){  
   test_button_A();
   test_button_B();
   test_button_prog();


  flashing_LED();
 
    }
 }


